<?php defined('SYSPATH') or die('No direct access allowed.');

/**
 * LDAP Configuration - LDAP Server Definitions
 *
 * @package    Kohana/LDAP
 * @category   Configuration
 * @author     Deon George
 * @copyright  (c) 2013 phpLDAPadmin Development Team
 * @license    http://dev.phpldapadmin.org/license.html
 */

return array (
	'default' => array (
		'type'       => 'LDAP',
		'connection' => array(
			/**
			 * The following options are available for MySQL:
			 *
			 * string   hostname     server hostname, or socket
			 * string   database     our basedn
			 * string   username     database username
			 * string   password     database password
			 * boolean  persistent   use persistent connections?
			 *
			 * Ports and sockets may be appended to the hostname.
			 */
			'hostname'   => 'localhost',
			'database'   => NULL,
			'port'       => 389,
			'username'   => FALSE,
			'password'   => FALSE,
			'persistent' => NULL,
		),
		'table_prefix' => NULL,
		'charset'      => 'utf8',
		'caching'      => FALSE, // If this LDAP server is enabled for cache TRUE|FALSE
		'profiling'    => TRUE,

		'login_attr'=>'uid',
		'schema'=>array(
			'dn'         => FALSE,
			'password'   => FALSE,
		),
	),
);
?>
